/*
 File: linker_id.h
 Date and Time: Fri Jan 30 18:55:14 2015 
*/
#ifndef __linker_id_h__
#define __linker_id_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "yacco2_stbl.h"
  
extern yacco2::Thread_entry ITH_linker_id;

extern yacco2::State S1_Clinker_id;
namespace NS_linker_id {
yacco2::THR _YACCO2_CALL_TYPE
TH_linker_id(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_linker_id(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[11];
};
class Clinker_id: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rlinker_id_ = 569//start_of_rule_list + 0
    ,rhs1_Rlinker_id_ = 1
    ,rhs2_Rlinker_id_ = 2
   ,R_Rtail_chars_ = 570//start_of_rule_list + 2
    ,rhs1_Rtail_chars_ = 3
    ,rhs2_Rtail_chars_ = 4
   ,R_Rstart_char_ = 571//start_of_rule_list + 4
    ,rhs1_Rstart_char_ = 5
    ,rhs2_Rstart_char_ = 6
    ,rhs3_Rstart_char_ = 7
    ,rhs4_Rstart_char_ = 8
   ,R_Rtail_char_ = 572//start_of_rule_list + 6
    ,rhs1_Rtail_char_ = 9
    ,rhs2_Rtail_char_ = 10
   ,R_Rno_and_underscore_and_hyphen_ = 573//start_of_rule_list + 8
    ,rhs1_Rno_and_underscore_and_hyphen_ = 11
    ,rhs2_Rno_and_underscore_and_hyphen_ = 12
    ,rhs3_Rno_and_underscore_and_hyphen_ = 13
    ,rhs4_Rno_and_underscore_and_hyphen_ = 14
    ,rhs5_Rno_and_underscore_and_hyphen_ = 15
   ,R_Rminus_la_ = 574//start_of_rule_list + 10
    ,rhs1_Rminus_la_ = 16
    ,rhs2_Rminus_la_ = 17
    ,rhs3_Rminus_la_ = 18
    ,rhs4_Rminus_la_ = 19
    ,rhs5_Rminus_la_ = 20
    ,rhs6_Rminus_la_ = 21
    ,rhs7_Rminus_la_ = 22
    ,rhs8_Rminus_la_ = 23
    ,rhs9_Rminus_la_ = 24
   ,R_RUPPER_A_M_ = 575//start_of_rule_list + 12
    ,rhs1_RUPPER_A_M_ = 25
    ,rhs2_RUPPER_A_M_ = 26
    ,rhs3_RUPPER_A_M_ = 27
    ,rhs4_RUPPER_A_M_ = 28
    ,rhs5_RUPPER_A_M_ = 29
    ,rhs6_RUPPER_A_M_ = 30
    ,rhs7_RUPPER_A_M_ = 31
    ,rhs8_RUPPER_A_M_ = 32
    ,rhs9_RUPPER_A_M_ = 33
    ,rhs10_RUPPER_A_M_ = 34
    ,rhs11_RUPPER_A_M_ = 35
    ,rhs12_RUPPER_A_M_ = 36
    ,rhs13_RUPPER_A_M_ = 37
   ,R_RUPPER_N_Z_ = 576//start_of_rule_list + 14
    ,rhs1_RUPPER_N_Z_ = 38
    ,rhs2_RUPPER_N_Z_ = 39
    ,rhs3_RUPPER_N_Z_ = 40
    ,rhs4_RUPPER_N_Z_ = 41
    ,rhs5_RUPPER_N_Z_ = 42
    ,rhs6_RUPPER_N_Z_ = 43
    ,rhs7_RUPPER_N_Z_ = 44
    ,rhs8_RUPPER_N_Z_ = 45
    ,rhs9_RUPPER_N_Z_ = 46
    ,rhs10_RUPPER_N_Z_ = 47
    ,rhs11_RUPPER_N_Z_ = 48
    ,rhs12_RUPPER_N_Z_ = 49
    ,rhs13_RUPPER_N_Z_ = 50
   ,R_Rlower_a_m_ = 577//start_of_rule_list + 16
    ,rhs1_Rlower_a_m_ = 51
    ,rhs2_Rlower_a_m_ = 52
    ,rhs3_Rlower_a_m_ = 53
    ,rhs4_Rlower_a_m_ = 54
    ,rhs5_Rlower_a_m_ = 55
    ,rhs6_Rlower_a_m_ = 56
    ,rhs7_Rlower_a_m_ = 57
    ,rhs8_Rlower_a_m_ = 58
    ,rhs9_Rlower_a_m_ = 59
    ,rhs10_Rlower_a_m_ = 60
    ,rhs11_Rlower_a_m_ = 61
    ,rhs12_Rlower_a_m_ = 62
    ,rhs13_Rlower_a_m_ = 63
   ,R_Rlower_n_z_ = 578//start_of_rule_list + 18
    ,rhs1_Rlower_n_z_ = 64
    ,rhs2_Rlower_n_z_ = 65
    ,rhs3_Rlower_n_z_ = 66
    ,rhs4_Rlower_n_z_ = 67
    ,rhs5_Rlower_n_z_ = 68
    ,rhs6_Rlower_n_z_ = 69
    ,rhs7_Rlower_n_z_ = 70
    ,rhs8_Rlower_n_z_ = 71
    ,rhs9_Rlower_n_z_ = 72
    ,rhs10_Rlower_n_z_ = 73
    ,rhs11_Rlower_n_z_ = 74
    ,rhs12_Rlower_n_z_ = 75
    ,rhs13_Rlower_n_z_ = 76
   ,R_RNUMBERS_ = 579//start_of_rule_list + 20
    ,rhs1_RNUMBERS_ = 77
    ,rhs2_RNUMBERS_ = 78
    ,rhs3_RNUMBERS_ = 79
    ,rhs4_RNUMBERS_ = 80
    ,rhs5_RNUMBERS_ = 81
    ,rhs6_RNUMBERS_ = 82
    ,rhs7_RNUMBERS_ = 83
    ,rhs8_RNUMBERS_ = 84
    ,rhs9_RNUMBERS_ = 85
    ,rhs10_RNUMBERS_ = 86
  };
  //no of la sets = 2
  //no of states = 80
  Clinker_id();
  ~Clinker_id();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[87];
  
    public:
    std::string data_;
  
 };
struct Rlinker_id;
struct Rtail_chars;
struct Rstart_char;
struct Rtail_char;
struct Rno_and_underscore_and_hyphen;
struct Rminus_la;
struct RUPPER_A_M;
struct RUPPER_N_Z;
struct Rlower_a_m;
struct Rlower_n_z;
struct RNUMBERS;
struct Rlinker_id:public yacco2::CAbs_lr1_sym {
  Rlinker_id(yacco2::Parser* P);
  void op();
  public:
};

struct Rtail_chars:public yacco2::CAbs_lr1_sym {
  Rtail_chars(yacco2::Parser* P);
  public:
};

struct Rstart_char:public yacco2::CAbs_lr1_sym {
  Rstart_char(yacco2::Parser* P);
  public:
};

struct Rtail_char:public yacco2::CAbs_lr1_sym {
  Rtail_char(yacco2::Parser* P);
  public:
};

struct Rno_and_underscore_and_hyphen:public yacco2::CAbs_lr1_sym {
  Rno_and_underscore_and_hyphen(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
};

struct Rminus_la:public yacco2::CAbs_lr1_sym {
  Rminus_la(yacco2::Parser* P);
  public:
};

struct RUPPER_A_M:public yacco2::CAbs_lr1_sym {
  RUPPER_A_M(yacco2::Parser* P);
  void op();
  public:
};

struct RUPPER_N_Z:public yacco2::CAbs_lr1_sym {
  RUPPER_N_Z(yacco2::Parser* P);
  void op();
  public:
};

struct Rlower_a_m:public yacco2::CAbs_lr1_sym {
  Rlower_a_m(yacco2::Parser* P);
  void op();
  public:
};

struct Rlower_n_z:public yacco2::CAbs_lr1_sym {
  Rlower_n_z(yacco2::Parser* P);
  void op();
  public:
};

struct RNUMBERS:public yacco2::CAbs_lr1_sym {
  RNUMBERS(yacco2::Parser* P);
  void op();
  public:
};

} // end of namespace

#endif
